package org.xml.sax.helpers;

import java.lang.reflect.InvocationTargetException;

class NewInstance
{
    private static final String DEFAULT_PACKAGE = "com.sun.org.apache.xerces.internal";
    
    NewInstance() {
    }
    
    static Object newInstance(ClassLoader classLoader, String className) throws ClassNotFoundException, IllegalAccessException, InstantiationException {
        boolean internal = false;
        if (System.getSecurityManager() != null && className != null && className.startsWith("com.sun.org.apache.xerces.internal")) {
            internal = true;
        }
        Class<Object> driverClass;
        if (classLoader == null || internal) {
            driverClass = Class.forName(className);
        }
        else {
            driverClass = classLoader.loadClass(className);
        }
        try {
            return driverClass.getConstructor(new Class[0]).newInstance(new Object[0]);
        }
        catch (NoSuchMethodException | SecurityException | InvocationTargetException ex) {
            throw new InstantiationException(ex.getMessage());
        }
    }
}
